using UnityEngine;
using System.Collections.Generic;
using Oxide.Game.Rust.Cui;
using System;
using Newtonsoft.Json;
using Oxide.Core.Plugins;

namespace Oxide.Plugins
{
    [Info("ZBoxesUI", "ZH3LL", "2.0.0")]
    [Description("Z Boxes UI")]
    internal class ZBoxesUI : RustPlugin
    {	
		[PluginReference]
        private Plugin ZBoxesPack, FridgeFarmZ, Economics, ServerRewards, ImageLibrary, RecyclerBox, MiningQuarryBox, ResearcHBox, RepairBox, FurnaceBox, DroppedItemBoxCollectorZ;

		private PluginConfig _ZBoxesUI { get; set;}		
		protected override void SaveConfig() => Config.WriteObject(_ZBoxesUI);		
		private const string __IRC = "https://static.wikia.nocookie.net/play-rust/images/e/ef/Recycler_icon.png/revision/latest?cb=20161105162407";	
		private const string __MQB = "https://static.wikia.nocookie.net/play-rust/images/b/b8/Mining_Quarry_icon.png/revision/latest?cb=20151106054421";	
		private const string __ResB = "https://static.wikia.nocookie.net/play-rust/images/2/21/Research_Table_icon.png/revision/latest?cb=20160129014240";	
		private const string __RepB = "https://static.wikia.nocookie.net/play-rust/images/3/3b/Repair_Bench_icon.png/revision/latest?cb=20151119214020";	
		private const string __FZB = "https://static.wikia.nocookie.net/play-rust/images/e/e3/Furnace_icon.png/revision/latest?cb=20151106054341";	
		private const string __DIBC = "https://rustlabs.com/img/skins/324/14184.png";	
		private const string __Scrap = "https://static.wikia.nocookie.net/play-rust/images/0/03/Scrap_icon.png/revision/latest?cb=20170721095804";	
		private const string __fridge = "https://static.wikia.nocookie.net/play-rust/images/3/35/Large_Planter_Box_icon.png/revision/latest?cb=20161214151746";		
		private void OnPlayerDisconnected(BasePlayer player) => CuiHelper.DestroyUi(player, "ZbUi");
		private void OnPlayerRespawned(BasePlayer player) => CuiHelper.DestroyUi(player, "ZbUi");	
		private void OnLootEntityEnd(BasePlayer player, BaseCombatEntity entity) => CuiHelper.DestroyUi(player, "ZbUi");
		
        private void OnServerInitialized()
        {		

			NextTick(() =>
			{			
			if(ZBoxesPack != null)
			{
			Puts("Duplicated plugin: ZBoxesUI.cs found in ZBoxesPack! Unload ZBoxesUI");
			Server.Command("o.unload ZBoxesUI");			
			}		
			});
			
			if(ImageLibrary == null)
            {
                Puts("Error: ImageLibrary is not loaded. Plugin Unloaded!");
				Server.Command("o.unload ZBoxesUI");
				return;
            }
			else
			{
                if (!ImageLibrary.Call<bool>("HasImage", __IRC))
                    ImageLibrary.Call("AddImage", __IRC, __IRC, 0UL);
				
                if (!ImageLibrary.Call<bool>("HasImage", __MQB))
                    ImageLibrary.Call("AddImage", __MQB, __MQB, 0UL);

				if (!ImageLibrary.Call<bool>("HasImage", __ResB))
                    ImageLibrary.Call("AddImage", __ResB, __ResB, 0UL);

				if (!ImageLibrary.Call<bool>("HasImage", __RepB))
                    ImageLibrary.Call("AddImage", __RepB, __RepB, 0UL);

				if (!ImageLibrary.Call<bool>("HasImage", __FZB))
                    ImageLibrary.Call("AddImage", __FZB, __FZB, 0UL);

				if (!ImageLibrary.Call<bool>("HasImage", __DIBC))
                    ImageLibrary.Call("AddImage", __DIBC, __DIBC, 0UL);

				if (!ImageLibrary.Call<bool>("HasImage", __Scrap))
                    ImageLibrary.Call("AddImage", __Scrap, __Scrap, 0UL);

				if (!ImageLibrary.Call<bool>("HasImage", __fridge))
                    ImageLibrary.Call("AddImage", __fridge,__fridge, 0UL);					
			}
			permission.RegisterPermission("ZBoxesUI.CanUse", this);
			permission.RegisterPermission("ZBoxesUI.FreeBuy", this);
			
		if(_ZBoxesUI.BoxtypeZBUICost == 2 && !Economics){Puts("Economics plugin missing!"); rust.RunServerCommand("o.unload ZBoxesUI");}
		if(_ZBoxesUI.BoxtypeZBUICost == 3 && !ServerRewards){Puts("ServerRewards plugin missing!"); rust.RunServerCommand("o.unload ZBoxesUI");}			
		}


        void OnLootEntity(BasePlayer player, BoxStorage entity)
        {
			if(player == null || entity == null){return;}
			if(!player.userID.IsSteamId()){return;}			
			if(entity.skinID == 3084640228 || entity.skinID == 3137708597 || entity.skinID == 3144201633 || entity.skinID == 3247770012 || entity.skinID == 3171493217 || entity.skinID == 3299450471 || entity.skinID == 3252660967)
			{
			if(_ZBoxesUI.BoxtypeSELL > 0)
			ZBOXuiOPEN(player, entity, false, 0, true);
			}
			else
			{
			
			if(!permission.UserHasPermission(player.userID.ToString(), "ZBoxesUI.CanUse")){return;}	
			if(entity.ShortPrefabName != "box.wooden.large" && entity.ShortPrefabName != "woodbox_deployed" && entity.ShortPrefabName != "fridge.deployed"){return;}
				if(player.userID == entity.OwnerID )
				{
				ZBOXuiOPEN(player, entity, false, 0, false);	
				}
			}
		}		
		
		private void ZBOXuiOPEN(BasePlayer player, BoxStorage entity, bool errormessage, int cosTtT, bool SellIng)
        {
            if (player == null){return;}
			var PosSBuI1 = new UI4(370f, 635f, 570f, 680f);
			string CostNaMe = "";
			string CostNaMe2 = "";			
			string CostMaNe = "";			
			bool ScarpIMAgE = false;
			float UI_Posx = 1f;
			float UI_PosxWeight = 0.24f;
			float UI_PosxBetWeen = 0.01f;

			bool ZBUIFB = false;
			if(permission.UserHasPermission(player.userID.ToString(), "ZBoxesUI.FreeBuy"))
			{
			ZBUIFB = true;
			}
			
			if(!ZBUIFB)
			{
			if(_ZBoxesUI.BoxtypeZBUICost == 1){ScarpIMAgE = true; CostNaMe2 = "Scrap"; CostMaNe = "      ";}
			else if(_ZBoxesUI.BoxtypeZBUICost == 2)
			{
			CostNaMe = " <color=#66ff66>" + _ZBoxesUI.Eco + "</color>";
			CostNaMe2 = CostNaMe;
			}
			else if(_ZBoxesUI.BoxtypeZBUICost == 3)
			{
			CostNaMe = " <color=#66ff66>" + _ZBoxesUI.SRew + "</color>";
			CostNaMe2 = CostNaMe;			
			}
			}
			
			if(entity.ShortPrefabName == "fridge.deployed")
			{
			PosSBuI1 = new UI4(370f, 455f, 570f, 500f);
			}
			else if(entity.ShortPrefabName == "woodbox_deployed")
			{
			PosSBuI1 = new UI4(370f, 325f, 570f, 370f);
			}
			
			string price = "";
			
			CuiElementContainer container = null;
			container = UI.Container("ZbUi", "0 0 0 0", PosSBuI1, true);

			if(entity.ShortPrefabName == "box.wooden.large" && !SellIng)
			{
				
			if(_ZBoxesUI.BoxtypeZBUIIRC > 0 && RecyclerBox != null)
			{
			price = _ZBoxesUI.BoxtypeZBUIIRC.ToString();
			if(ZBUIFB){price = "";}
			var image = new CuiElement { Parent = "ZbUi", Name = "ZbUi_REC" }; image.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __IRC) }); image.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx + " 1", AnchorMin = UI_Posx-UI_PosxWeight + " 0" });
			container.Add(image);
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS = new CuiElement { Parent = "ZbUi", Name = "ZbUi_S" }; imageS.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f),  $"ZBUiCommIIU {entity.net.ID} {1} {_ZBoxesUI.BoxtypeZBUIIRC.ToString()}");
			UI_Posx -= UI_PosxBetWeen + UI_PosxWeight;
			}

			if(_ZBoxesUI.BoxtypeZBUIMQB > 0 && MiningQuarryBox != null)
			{
			price = _ZBoxesUI.BoxtypeZBUIMQB.ToString();
			if(ZBUIFB){price = "";}				
			var image2 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_MQB" }; image2.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __MQB) }); image2.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx + " 1", AnchorMin = UI_Posx-UI_PosxWeight + " 0" });
			container.Add(image2);	
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS2 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_S" }; imageS2.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS2.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS2);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), $"ZBUiCommIIU {entity.net.ID} {2} {_ZBoxesUI.BoxtypeZBUIMQB.ToString()}");
			UI_Posx -= UI_PosxBetWeen + UI_PosxWeight;
			}
			
			if(_ZBoxesUI.BoxtypeZBUIResB > 0 && ResearcHBox != null)
			{	
			price = _ZBoxesUI.BoxtypeZBUIResB.ToString();
			if(ZBUIFB){price = "";}		
			var image3 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_ResB" }; image3.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __ResB) }); image3.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx + " 1", AnchorMin = UI_Posx-UI_PosxWeight + " 0" });
			container.Add(image3);	
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS3 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_S" }; imageS3.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS3.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS3);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), $"ZBUiCommIIU {entity.net.ID} {3} {_ZBoxesUI.BoxtypeZBUIResB.ToString()}");
			UI_Posx -= UI_PosxBetWeen + UI_PosxWeight;
			}
			
			if(_ZBoxesUI.BoxtypeZBUIRepB > 0 && RepairBox != null)
			{	
			price = _ZBoxesUI.BoxtypeZBUIRepB.ToString();
			if(ZBUIFB){price = "";}		
			var image4 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_RepB" }; image4.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __RepB) }); image4.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx + " 1", AnchorMin = UI_Posx-UI_PosxWeight + " 0" });
			container.Add(image4);				
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS4 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_S" }; imageS4.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS4.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS4);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), $"ZBUiCommIIU {entity.net.ID} {4} {_ZBoxesUI.BoxtypeZBUIRepB.ToString()}");
			}
			
			}
			else if(entity.ShortPrefabName == "woodbox_deployed" && !SellIng)
			{
			if(_ZBoxesUI.BoxtypeZBUIFZB > 0 && FurnaceBox != null)
			{	
			price = _ZBoxesUI.BoxtypeZBUIFZB.ToString();
			if(ZBUIFB){price = "";}		
			var image5 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_FZB" }; image5.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __FZB) }); image5.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx + " 1", AnchorMin = UI_Posx-UI_PosxWeight + " 0" });
			container.Add(image5);	
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS5 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_S" }; imageS5.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS5.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS5);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), $"ZBUiCommIIU {entity.net.ID} {5} {_ZBoxesUI.BoxtypeZBUIFZB.ToString()}");
			UI_Posx -= UI_PosxBetWeen + UI_PosxWeight;
			}
			
			if(_ZBoxesUI.BoxtypeZBUIDIBC > 0 && DroppedItemBoxCollectorZ != null)
			{
			price = _ZBoxesUI.BoxtypeZBUIDIBC.ToString();
			if(ZBUIFB){price = "";}				
			var image6 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_DIBC" }; image6.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __DIBC) }); image6.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx + " 1", AnchorMin = UI_Posx-UI_PosxWeight + " 0" });
			container.Add(image6);				
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS6 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_S" }; imageS6.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS6.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS6);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), $"ZBUiCommIIU {entity.net.ID} {6} {_ZBoxesUI.BoxtypeZBUIDIBC.ToString()}");
			}
			}
			else if(entity.ShortPrefabName == "fridge.deployed" && !SellIng)
			{
			if(_ZBoxesUI.BoxtypeZBUIDIBCFFZ > 0 && FridgeFarmZ != null)
			{	
			price = _ZBoxesUI.BoxtypeZBUIDIBCFFZ.ToString();
			if(ZBUIFB){price = "";}		
			var image7 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_FZBFF" }; image7.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __fridge) }); image7.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx + " 1", AnchorMin = UI_Posx-UI_PosxWeight + " 0" });
			container.Add(image7);	
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS7 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_SFF" }; imageS7.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS7.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS7);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), $"ZBUiCommIIU {entity.net.ID} {7} {_ZBoxesUI.BoxtypeZBUIDIBCFFZ.ToString()}");
			UI_Posx -= UI_PosxBetWeen + UI_PosxWeight;
			}
			}
			else if(SellIng)
			{
			if(_ZBoxesUI.BoxtypeSELL > 0)
			{	
			price = _ZBoxesUI.BoxtypeSELL.ToString();
			if(ZBUIFB){price = "";}		
			UI.Button(ref container, "ZbUi", "0 0 0 0", "<color=red>X</color>", 30, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), "");	
			if(ScarpIMAgE && !ZBUIFB)
			{
			var imageS7 = new CuiElement { Parent = "ZbUi", Name = "ZbUi_SFF" }; imageS7.Components.Add(new CuiRawImageComponent { Png = ImageLibrary.Call<string>("GetImage", __Scrap) }); imageS7.Components.Add(new CuiRectTransformComponent { AnchorMax = UI_Posx-(UI_PosxWeight*0.6f) + " 0.4", AnchorMin = UI_Posx-(UI_PosxWeight) + " 0" });
			container.Add(imageS7);
			}
			UI.Button(ref container, "ZbUi", "0 0 0 0", "\n\n" + CostMaNe + "<color=#66ff66>" + price + "</color>" + CostNaMe, 12, new UI4(UI_Posx-UI_PosxWeight, 0f, UI_Posx, 1f), $"ZBUiCommIIU {entity.net.ID} {8} {_ZBoxesUI.BoxtypeSELL.ToString()}");
			UI_Posx -= UI_PosxBetWeen + UI_PosxWeight;
			}							
			}
			
			
			if(errormessage)
			{
			UI.Button2(ref container, "ZbUi", "1 0 0 0.2", lang.GetMessage("___CantBuy2", this, player.userID.ToString()).Replace("{0}", cosTtT.ToString()).Replace("{1}", CostNaMe2), 10, new UI4(0f, 1f, 1f, 1.5f), "");
			}
			
            CuiHelper.DestroyUi(player, "ZbUi");
            CuiHelper.AddUi(player, container);
        }	

        [ConsoleCommand("ZBUiCommIIU")]
        private void ZBUIEXEcute(ConsoleSystem.Arg arg)
        {
            BasePlayer player = arg.Connection.player as BasePlayer;
            if (player == null){ return;}
			
			if(arg.Args[0] == null || Convert.ToInt32(arg.Args[1]) < 1 || Convert.ToInt32(arg.Args[1]) > 8 || Convert.ToInt32(arg.Args[2]) < 1){return;}
			var entityBOX = BaseNetworkable.serverEntities.Find(new NetworkableId(Convert.ToUInt64(Convert.ToUInt64(arg.Args[0]))));
            if (entityBOX == null){ return;}			
			if(entityBOX as BoxStorage){}else{return;}			
			var entityBoxZBUI = entityBOX as BaseEntity;
			string TyppeGettNow = "";

			if(_ZBoxesUI.BoxtypeZBUICost == 1){TyppeGettNow = "scrap";}
			else if(_ZBoxesUI.BoxtypeZBUICost == 2){TyppeGettNow = "eco";}
			else if(_ZBoxesUI.BoxtypeZBUICost == 3){TyppeGettNow = "rp";}			

			if(ZBOXCheckBalance(player, TyppeGettNow, Convert.ToInt32(arg.Args[2])))
			{
					if(Convert.ToInt32(arg.Args[1]) == 1){entityBoxZBUI.skinID = 3084640228;}
					if(Convert.ToInt32(arg.Args[1]) == 2){entityBoxZBUI.skinID = 3299450471;}
					if(Convert.ToInt32(arg.Args[1]) == 3){entityBoxZBUI.skinID = 3137708597;}
					if(Convert.ToInt32(arg.Args[1]) == 4){entityBoxZBUI.skinID = 3144201633;}
					if(Convert.ToInt32(arg.Args[1]) == 5){entityBoxZBUI.skinID = 3171493217;}
					if(Convert.ToInt32(arg.Args[1]) == 6){entityBoxZBUI.skinID = 3247770012;}
					if(Convert.ToInt32(arg.Args[1]) == 7){entityBoxZBUI.skinID = 3252660967;}
					if(Convert.ToInt32(arg.Args[1]) == 8){entityBoxZBUI.skinID = 0;}										

				if(Convert.ToInt32(arg.Args[1]) == 8)
				{
				CuiHelper.DestroyUi(player, "ZbUi");
				ZBOXuiOPEN(player, entityBoxZBUI as BoxStorage, false, Convert.ToInt32(arg.Args[2]), false);	
				}
				else
				{
				CuiHelper.DestroyUi(player, "ZbUi");
				ZBOXuiOPEN(player, entityBoxZBUI as BoxStorage, false, Convert.ToInt32(arg.Args[2]), true);	
				}

					}
			else
			{
								if(Convert.ToInt32(arg.Args[1]) == 8)
								{
								CuiHelper.DestroyUi(player, "ZbUi");
								ZBOXuiOPEN(player, entityBoxZBUI as BoxStorage, true, Convert.ToInt32(arg.Args[2]), true);										
								}
								else
								{
								CuiHelper.DestroyUi(player, "ZbUi");
								ZBOXuiOPEN(player, entityBoxZBUI as BoxStorage, true, Convert.ToInt32(arg.Args[2]), false);	
								}
			}

        }	
		
		private bool ZBOXCheckBalance(BasePlayer player, string currencyType, int amount)
        {
			if(permission.UserHasPermission(player.userID.ToString(), "ZBoxesUI.FreeBuy")){return true;}	
			if (currencyType == "rp")
            {
                if (ServerRewards == null)
                { Puts("ServerRewards is not loaded!"); return false; }

                var playersRP = ServerRewards?.Call<int>("CheckPoints", player.userID);

                if (playersRP < amount) return false;

                ServerRewards?.Call("TakePoints", player.userID, amount);
                return true;
            }
            else if (currencyType == "eco")
            {
                if (Economics == null)
                { Puts("Economics is not loaded!"); return false; }
			
                double playersEco = Economics.Call<double>("Balance", player.UserIDString);

                if (playersEco < amount)
                {
                    return false;
                }
                Economics.CallHook("Withdraw", player.UserIDString, Convert.ToDouble(amount));
                return true;
            }
			else if (currencyType == "scrap")
            {
			if (player.inventory.GetAmount(-932201673) >= Convert.ToInt32(amount))
				{
				player.inventory.Take(null, -932201673, Convert.ToInt32(amount));
				return true;
				}
			}					
            return false;

        }
		
		
	        public static class UI
        {
            public static CuiElementContainer Container(string panelName, string color, UI4 dimensions, bool useCursor = false, string parent = "Overlay")
            {
                CuiElementContainer container = new CuiElementContainer()
                {
                    {
                        new CuiPanel
                        {
                            Image = {Color = color},
							RectTransform = 
							{ 
							AnchorMin = "0.5 0", 
							AnchorMax = "0.5 0", 
							OffsetMin = dimensions.GetMin(), 
							OffsetMax = dimensions.GetMax() 
							},
                            CursorEnabled = useCursor
                        },
                        new CuiElement().Parent = parent,
                        panelName.ToString()
                    }
                };
                return container;
            }			
			
            public static void Button(ref CuiElementContainer container, string panel, string color, string text, int size, UI4 dimensions, string command, TextAnchor align = TextAnchor.MiddleLeft)
            {
                container.Add(new CuiButton
                {
                    Button = { Color = color, Command = command, FadeIn = 0f },
                    RectTransform = { AnchorMin = dimensions.GetMin(), AnchorMax = dimensions.GetMax() },
                    Text = { Text = text, FontSize = size, Align = align }
                },
                panel.ToString());
            }
 
            public static void Button2(ref CuiElementContainer container, string panel, string color, string text, int size, UI4 dimensions, string command, TextAnchor align = TextAnchor.MiddleCenter)
            {
                container.Add(new CuiButton
                {
                    Button = { Color = color, Command = command, FadeIn = 0f },
                    RectTransform = { AnchorMin = dimensions.GetMin(), AnchorMax = dimensions.GetMax() },
                    Text = { Text = text, FontSize = size, Align = align }
                },
                panel.ToString());
            }
			
        }	
		
		        public class UI4
        {
            [JsonProperty(PropertyName = "Left (0.0 - 1.0)")]
            public float xMin;

            [JsonProperty(PropertyName = "Bottom (0.0 - 1.0)")]
            public float yMin;

            [JsonProperty(PropertyName = "Right (0.0 - 1.0)")]
            public float xMax;

            [JsonProperty(PropertyName = "Top (0.0 - 1.0)")]
            public float yMax;

            public UI4(float xMin, float yMin, float xMax, float yMax)
            {
                this.xMin = xMin;
                this.yMin = yMin;
                this.xMax = xMax;
                this.yMax = yMax;
            }

            public string GetMin() => $"{xMin} {yMin}";
            public string GetMax() => $"{xMax} {yMax}";
        }
		
			public class PluginConfig
			{
            [JsonProperty("Cost type: (1=Scrap, 2=Economics, 3=ServerRewards)")] public int BoxtypeZBUICost = 1;
            [JsonProperty("Economics")] public string Eco = "$";
            [JsonProperty("ServerRewards")] public string SRew = "SR";			
            [JsonProperty("[PLUGIN] Cost for InstantRecyclerBox (0 = disable plugin):")] public int BoxtypeZBUIIRC = 1;
            [JsonProperty("[PLUGIN] Cost for MiningQuarryBox (0 = disable plugin):")] public int BoxtypeZBUIMQB = 1;
            [JsonProperty("[PLUGIN] Cost for ResearchBox (0 = disable plugin):")] public int BoxtypeZBUIResB = 1;
            [JsonProperty("[PLUGIN] Cost for RepairBox (0 = disable plugin):")] public int BoxtypeZBUIRepB = 1;			
            [JsonProperty("[PLUGIN] Cost for FurnaceZBOX (0 = disable plugin):")] public int BoxtypeZBUIFZB = 1;	
            [JsonProperty("[PLUGIN] Cost for DroppedItemBoxCollector (0 = disable plugin):")] public int BoxtypeZBUIDIBC = 1;	
            [JsonProperty("[PLUGIN] Cost for FridgeFarmZ (0 = disable plugin):")] public int BoxtypeZBUIDIBCFFZ = 1;	
            [JsonProperty("[PLUGIN] Selling price (back to normal box) / (0 = disable)")] public int BoxtypeSELL = 1;	
			
			public static PluginConfig DefaultConfig()
				{
					return new PluginConfig()
					{
					 BoxtypeZBUICost = 1,
					 Eco = "$",
					 SRew = "SR",
					 BoxtypeZBUIIRC = 1,
					 BoxtypeZBUIMQB = 1,
					 BoxtypeZBUIResB = 1,
					 BoxtypeZBUIRepB = 1,
					 BoxtypeZBUIFZB = 1,
					 BoxtypeZBUIDIBC = 1,
					 BoxtypeZBUIDIBCFFZ = 1,
					 BoxtypeSELL = 1
					};
                }
				
				

			}
			
        protected override void LoadConfig()
        {
        base.LoadConfig();
        _ZBoxesUI = Config.ReadObject<PluginConfig>();
        SaveConfig();
        }
			
		protected override void LoadDefaultConfig()
        {
            Puts("Creating a default config...");
            _ZBoxesUI = PluginConfig.DefaultConfig();
            SaveConfig();
            Puts("Creation of the default config completed!");
        }			
			
        private void Unload()
        {		
			foreach (BasePlayer player in BasePlayer.activePlayerList)
			{
			CuiHelper.DestroyUi(player, "ZbUi");
			}
		}

        protected override void LoadDefaultMessages()
        {
            lang.RegisterMessages(new Dictionary<string, string>
            {
                ["___CantBuy2"] = "You can't buy it! The price: <color=#66ff66>{0}</color> {1}",				
            }, this);
		}			
	
	}
}